---------------------------------------------------------------------
--== Import ===--
---------------------------------------------------------------------

import "Turbine.Gameplay"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Souru.SkillTimer.Shortcut"
import "Souru.SkillTimer.Type"
import "Souru.SkillTimer.Class"
import "Souru.SkillTimer.UI"


---------------------------------------------------------------------
--==  ===--
---------------------------------------------------------------------

SaveFile = nil
Windows = {}
OptionsWindow = nil

me = Turbine.Gameplay.LocalPlayer.GetInstance()
class = me:GetClass()

skillList = me:GetTrainedSkills()

---------------------------------------------------------------------
--== Basic Functions ===--
---------------------------------------------------------------------

function Save()

	Turbine.PluginData.Save(Turbine.DataScope.Character, "SkillSaveFile", SaveFile)

end

function mysplit (inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end

function FindSkill(name)

	for i=1 , skillList:GetCount() , 1 do

		if name == skillList:GetItem(i):GetSkillInfo():GetName() then
		
			return skillList:GetItem(i)
		
		end
	
	end
		
	return nil

end

findalignment = function(number)
	if number == 1 then
		return Turbine.UI.ContentAlignment.TopLeft;
	elseif number == 2 then
		return Turbine.UI.ContentAlignment.TopCenter;
	elseif number == 3 then
		return Turbine.UI.ContentAlignment.TopRight;
	elseif number == 4 then
		return Turbine.UI.ContentAlignment.MiddleRight;
	elseif number == 5 then
		return Turbine.UI.ContentAlignment.MiddleCenter;
	elseif number == 6 then
		return Turbine.UI.ContentAlignment.MiddleLeft;
	elseif number == 7 then
		return Turbine.UI.ContentAlignment.BottomLeft;
	elseif number == 8 then
		return Turbine.UI.ContentAlignment.BottomCenter;
	elseif number == 9 then
		return Turbine.UI.ContentAlignment.BottomRight;
	end
end

findfont = function(number)
	if number == 1 then
		return Turbine.UI.Lotro.Font.Arial12;
	elseif number == 2 then
		return Turbine.UI.Lotro.Font.TrajanPro13;
	elseif number == 3 then
		return Turbine.UI.Lotro.Font.TrajanPro14;
	elseif number == 4 then
		return Turbine.UI.Lotro.Font.TrajanPro15;
	elseif number == 5 then
		return Turbine.UI.Lotro.Font.TrajanPro16;
	elseif number == 6 then
		return Turbine.UI.Lotro.Font.TrajanPro18;
	elseif number == 7 then
		return Turbine.UI.Lotro.Font.TrajanPro19;
	elseif number == 8 then
		return Turbine.UI.Lotro.Font.TrajanPro20;
	elseif number == 9 then
		return Turbine.UI.Lotro.Font.TrajanPro21;
	elseif number == 10 then
		return Turbine.UI.Lotro.Font.TrajanPro23;
	elseif number == 11 then
		return Turbine.UI.Lotro.Font.TrajanPro24;
	elseif number == 12 then
		return Turbine.UI.Lotro.Font.TrajanPro25;
	elseif number == 13 then
		return Turbine.UI.Lotro.Font.TrajanPro26;
	elseif number == 14 then
		return Turbine.UI.Lotro.Font.TrajanPro28;
	elseif number == 15 then
		return Turbine.UI.Lotro.Font.TrajanProBold16;
	elseif number == 16 then
		return Turbine.UI.Lotro.Font.TrajanProBold22;
	elseif number == 17 then
		return Turbine.UI.Lotro.Font.TrajanProBold24;
	elseif number == 18 then
		return Turbine.UI.Lotro.Font.TrajanProBold25;
	elseif number == 19 then
		return Turbine.UI.Lotro.Font.TrajanProBold30;
	elseif number == 20 then
		return Turbine.UI.Lotro.Font.TrajanProBold36;
	elseif number == 21 then
		return Turbine.UI.Lotro.Font.Verdana10;
	elseif number == 22 then
		return Turbine.UI.Lotro.Font.Verdana12;
	elseif number == 23 then
		return Turbine.UI.Lotro.Font.Verdana14;
	elseif number == 24 then
		return Turbine.UI.Lotro.Font.Verdana16;
	elseif number == 25 then
		return Turbine.UI.Lotro.Font.Verdana18;
	elseif number == 26 then
		return Turbine.UI.Lotro.Font.Verdana20;
	elseif number == 27 then
		return Turbine.UI.Lotro.Font.Verdana22;
	elseif number == 28 then
		return Turbine.UI.Lotro.Font.Verdana23;
	end
end


---------------------------------------------------------------------
--== Window Functions ===--
---------------------------------------------------------------------

function MoveWindows(bool)

	for i,window in ipairs(Windows) do
		window:Move(bool)
	end
	
	anchor.label:SetVisible(bool)
	anchor:SetMouseVisible(bool)
	
	if bool then
		anchor:SetBackColor(Turbine.UI.Color.Red)
	else
		anchor:SetBackColor()
	end

end


function RemoveWindow(index)

	for i=index, table.getn(SaveFile)-1, 1 do
	
		SaveFile[i] = SaveFile[i+1]
	
	end
	
	SaveFile[table.getn(SaveFile)] = nil
	Save()
	CreateWindows()

end

function AddNewWindow()

	local index = table.getn(SaveFile)+1
	
	SaveFile[index] = {}
	SaveFile[index]["name"] = "Window"..index
	SaveFile[index]["visible"] = true
	SaveFile[index]["orientation"] = true
	SaveFile[index]["distance"] = 30
	SaveFile[index]["opacity"] = 1
	SaveFile[index]["left"] = 500
	SaveFile[index]["top"] = 500
	SaveFile[index]["size"] = 32 
	
	AddNewSkillTo(index)

	return index

end

function ClearWindows()
	
	for i,window in ipairs(Windows) do
		Windows[i]:Remove()
		Windows[i] = nil
	end
	
end

function CreateWindows()

	if table.getn(Windows) > 0 then
		ClearWindows()
	end

	for i,data in ipairs(SaveFile) do
		Windows[i] = UI.Window(data)
	end

end


---------------------------------------------------------------------
--== Skill/Icon Functions ===--
---------------------------------------------------------------------

function RemoveItem(window, index)

	for i=index, table.getn(SaveFile[window])-1, 1 do
	
		SaveFile[window][i] = SaveFile[window][i+1]
	
	end
	
	SaveFile[window][table.getn(SaveFile[window])] = nil
	Save()
	CreateWindows()

end

function SwapItem(window, index, newIndex)
	
	
	if newIndex >= 1 and newIndex <= table.getn(SaveFile[window]) then
		local temp = SaveFile[window][index]
		SaveFile[window][index] = SaveFile[window][newIndex]
		SaveFile[window][newIndex] = temp

		Save()
		CreateWindows()
		
		return true
	else
		Turbine.Shell.WriteLine("Swaping not possible.")
		
		return false
	end

end

function AddNewSkillTo(window)

	local index = table.getn(SaveFile[window])+1
	
	SaveFile[window][index] = {}
	SaveFile[window][index]["name"] = "New Item"
	SaveFile[window][index]["data"] = nil
	SaveFile[window][index]["thresholdColor"] = {}
	
	if index > 1 then
	
		SaveFile[window][index]["showoffcd"] 			= SaveFile[window][index-1]["showoffcd"]
		SaveFile[window][index]["showoncd"] 			= SaveFile[window][index-1]["showoncd"]
		SaveFile[window][index]["popupanchor"] 			= SaveFile[window][index-1]["popupanchor"]
		SaveFile[window][index]["cdopacity"] 			= SaveFile[window][index-1]["cdopacity"]
		SaveFile[window][index]["showpopup"] 			= SaveFile[window][index-1]["showpopup"]
		SaveFile[window][index]["popupsize"] 			= SaveFile[window][index-1]["popupsize"]	
		SaveFile[window][index]["resetTimer"] 			= SaveFile[window][index-1]["resetTimer"]		
		SaveFile[window][index]["font"] 				= SaveFile[window][index-1]["font"]
		SaveFile[window][index]["alignment"] 			= SaveFile[window][index-1]["alignment"]
		SaveFile[window][index]["thresholdValue"] 		= SaveFile[window][index-1]["thresholdValue"]
		SaveFile[window][index]["thresholdAlignment"] 	= SaveFile[window][index-1]["thresholdAlignment"]
		SaveFile[window][index]["thresholdFont"] 		= SaveFile[window][index-1]["thresholdFont"]
		SaveFile[window][index]["thresholdColor"]["R"] 	= SaveFile[window][index-1]["thresholdColor"]["R"]
		SaveFile[window][index]["thresholdColor"]["G"]	= SaveFile[window][index-1]["thresholdColor"]["G"]
		SaveFile[window][index]["thresholdColor"]["B"]	= SaveFile[window][index-1]["thresholdColor"]["B"]

	else
	
		SaveFile[window][index]["showoffcd"] = true
		SaveFile[window][index]["showoncd"] = true
		SaveFile[window][index]["popupanchor"] = true
		SaveFile[window][index]["cdopacity"] = 0.4
		SaveFile[window][index]["showpopup"] = true
		SaveFile[window][index]["popupsize"] = 200		
		SaveFile[window][index]["resetTimer"] = 0
		SaveFile[window][index]["font"] = 15
		SaveFile[window][index]["alignment"] = 9
		SaveFile[window][index]["thresholdValue"] = 6
		SaveFile[window][index]["thresholdFont"] = 19
		SaveFile[window][index]["thresholdAlignment"] = 5
		SaveFile[window][index]["thresholdColor"]["R"] = 1
		SaveFile[window][index]["thresholdColor"]["G"] = 0
		SaveFile[window][index]["thresholdColor"]["B"] = 0
	
	end
	
	Save()

	return index

end


---------------------------------------------------------------------
--== Pop-Up Anchor  ===--
---------------------------------------------------------------------

anchor = Turbine.UI.Window()
anchor:SetPosition(700,500)
anchor:SetSize(100,100)
anchor:SetMouseVisible(false)
anchor:SetVisible(true)

anchor.label = Turbine.UI.Label()
anchor.label:SetParent(anchor)
anchor.label:SetSize(anchor:GetSize())
anchor.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
anchor.label:SetText("Pop-Up Anchor")
anchor.label:SetVisible(false)
anchor.label:SetMouseVisible(false)

anchor.MouseDown = function( sender, args )
	if args.Button == Turbine.UI.MouseButton.Left then
		anchor.dragging = true	
		anchor.dragStartX = args.X
		anchor.dragStartY = args.Y
	end

end

anchor.MouseMove = function( sender, args )
	if anchor.dragging then
		local x,y = anchor:GetPosition()	
		x = x + ( args.X - anchor.dragStartX )
		y = y + ( args.Y - anchor.dragStartY )	
		anchor:SetPosition( x, y )	
	end
end

anchor.MouseUp = function( sender, args )
	if args.Button == Turbine.UI.MouseButton.Left then
		anchor.dragging = false
		SaveFile["anchorleft"],SaveFile["anchortop"] = anchor:GetPosition()
		Save()
	end
end

---------------------------------------------------------------------
--== LoadIn  ===--
---------------------------------------------------------------------


if Turbine.PluginData.Load(Turbine.DataScope.Character, "SkillSaveFile") ~= nil then

	SaveFile = Turbine.PluginData.Load(Turbine.DataScope.Character, "SkillSaveFile")
	anchor:SetPosition(SaveFile["anchorleft"], SaveFile["anchortop"])
	CreateWindows()

else

	SaveFile = {}
	SaveFile["anchorleft"] = 700
	SaveFile["anchortop"] = 500
		
end



---------------------------------------------------------------------
--== Chat-Comands  ===--
---------------------------------------------------------------------

command = Turbine.ShellCommand()

function command:Execute( _, str )
    if str == nil or string.len( str ) == 0 then
        return
    end

    local list  = { }
    local index = 1

    for word in str:gmatch( "%w+" ) do
        list[ index ] = word
        index = index + 1
    end

    local cmd = string.lower( list[ 1 ] )

    if cmd == "options" then
       
	   if OptionsWindow == UI.OptionsWindow() then
			
			OptionsWindow = UI.OptionsWindow()

	   end
	   
    elseif cmd == "reload" then
      
	  CreateWindows()
	  
    elseif table.getn(list) == 2 then

		if list[1] == "unload" then
		
			for i,window in ipairs(SaveFile) do
				if string.lower(window["name"]) == string.lower(list[2]) then
					window["visible"] = false
					Turbine.Shell.WriteLine("Window: ''"..list[2].."'' turned off.")
					 CreateWindows()
					 return
				end
			end
			
			Turbine.Shell.WriteLine( "Invalid Window Name: " .. string.lower(list[1]) )
		
		elseif list[1] == "load" then
		
			for i,window in ipairs(SaveFile) do
				if string.lower(window["name"]) == string.lower(list[2]) then
					window["visible"] = true
					Turbine.Shell.WriteLine("Window: ''"..list[2].."'' turned on.")
					 CreateWindows()
					 return
				end
			end
			
			Turbine.Shell.WriteLine( "Invalid Window Name: " .. list[1] )

		else
		
			Turbine.Shell.WriteLine( "Invalid command: " .. cmd )
		
		end
		
	else
        Turbine.Shell.WriteLine( "Invalid command: " .. cmd )
    end
end

Turbine.Shell.AddCommand( "st", command )
Turbine.Shell.AddCommand( "skilltimer", command )

Turbine.Shell.WriteLine("SkillTimer: usage: /st [options][reload][load <windowname>][unload <windowname>]")


---------------------------------------------------------------------
--== Chat-Received  ===--
---------------------------------------------------------------------

anchor.resetTime = 0

function anchor:Update()

	if anchor.resetTime < Turbine.Engine.GetGameTime() then
	
		anchor:SetWantsUpdates(false)
		CreateWindows()
	
	end

end


function Turbine.Chat.Received(sender, args)

	if args.ChatType == Turbine.ChatType.Advancement then

		local message_begin = string.find(args.Message, "You have acquired the Class Specialization Bonus Trait:");
		
		if message_begin ~= nil then
			anchor.resetTime = Turbine.Engine.GetGameTime()+3
			anchor:SetWantsUpdates(true)
			
		end
		
	end
	
end


