
Window = class( Turbine.UI.Window )

function Window:Constructor(data)
	Turbine.UI.Window.Constructor( self )
	
	self.data = data
	self.items = {}
	
	self:SetPosition(data["left"], data["top"])
	self:SetOpacity(data["opacity"])
	self:SetMouseVisible(false)
	
	local left
	local top
	
	if data["visible"] then
	
		if table.getn(data) > 0 then
		
			for i,itemData in ipairs(data) do
			
				if data["orientation"] then
					left = 0
					top	 = (i-1)*(data["size"]+data["distance"])
				else
					left = (i-1)*(data["size"]+data["distance"])
					top	 = 0
				end
			
				self.items[i] = Icon(itemData, self, data["size"], left, top, data["opacity"])
			
			end
			
			if data["orientation"] then
				self:SetSize((data["size"]),(table.getn(data))*(data["size"]+data["distance"])-data["distance"])
			else
				self:SetSize((table.getn(data))*(data["size"]+data["distance"])-data["distance"],(data["size"]))
			end
				
			self:SetVisible(true)
		
		else
		
			self:SetVisible(false)
		
		end
		
		self.MouseDown = function( sender, args )
			if args.Button == Turbine.UI.MouseButton.Left then
				self.dragging = true	
				self.dragStartX = args.X
				self.dragStartY = args.Y
			end
		
		end
		
		self.MouseMove = function( sender, args )
			if self.dragging then
				local x,y = self:GetPosition()	
				x = x + ( args.X - self.dragStartX )
				y = y + ( args.Y - self.dragStartY )	
				self:SetPosition( x, y )	
			end
		end
		
		self.MouseUp = function( sender, args )
			if args.Button == Turbine.UI.MouseButton.Left then
				self.dragging = false
				self.data["left"],self.data["top"] = self:GetPosition()
				Save()
			end
		end
	
	else
	
		self:SetVisible(false)
	
	end
	
end

function Window:Move(bool)

	self:SetMouseVisible(bool)
	
	if bool then
		self:SetBackColor(Turbine.UI.Color.Blue)
	else
		self:SetBackColor()
	end

end

function Window:Remove()

	self:SetVisible(false)

end
